/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */
/*
 * Copyright (c) 1997-1999 by Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef	_DB_H
#define	_DB_H

#pragma ident	"%Z%%M%	%I%	%E% SMI"

#ifdef	__cplusplus
extern "C" {
#endif

/* Generated by m4 */
extern void db_set_current_library(char const *);
extern char *db_get_current_library(void);
extern void db_set_current_file(char const *);
extern char *db_get_current_file(void);
extern void db_set_output_file(char const *);
extern char *db_get_output_file(void);
extern void db_set_current_interface(char const *);
extern char *db_get_current_interface(void);
extern void db_set_source_directory(char const *);
extern char *db_get_source_directory(void);
extern void db_set_target_directory(char const *);
extern char *db_get_target_directory(void);

/* By hand. */
extern void db_add_print_types(char *, char *);
extern char *db_get_first_print_type(void);
extern char *db_get_next_print_type(void);
extern void db_sort_print_types(void);
extern void db_print_print_types(void);

extern void db_set_arch(char const *);
extern char const *db_get_arch(void);

extern void db_report();

#ifdef	__cplusplus
}
#endif

#endif	/* _DB_H */
