/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */
/*
 * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#ifndef _MPATHADM_TEXT_H
#define	_MPATHADM_TEXT_H

#ifdef	__cplusplus
extern "C" {
#endif

MP_CHAR * getTextString(int stringVal);

/* define string values */
enum textStrings {
	TEXT_UNKNOWN,
	TEXT_LBTYPE_FAILOVER_ONLY,
	TEXT_LBTYPE_LBAREGION,
	TEXT_LBTYPE_DEVICEPROD,
	TEXT_LBTYPE_LEASTIO,
	TEXT_LBTYPE_LEASTBLOCKS,
	TEXT_LBTYPE_ROUNDROBIN,
	TEXT_LBTYPE_UNKNOWN,
	TEXT_LBTYPE_NONE,
	TEXT_LBTYPE_PROPRIETARY1,
	TEXT_LBTYPE_PROPRIETARY2,
	TEXT_LBTYPE_PROPRIETARY3,
	TEXT_LBTYPE_PROPRIETARY4,
	TEXT_LBTYPE_PROPRIETARY5,
	TEXT_LBTYPE_PROPRIETARY6,
	TEXT_LBTYPE_PROPRIETARY7,
	TEXT_LBTYPE_PROPRIETARY8,
	TEXT_LBTYPE_PROPRIETARY9,
	TEXT_LBTYPE_PROPRIETARY10,
	TEXT_LBTYPE_PROPRIETARY11,
	TEXT_LBTYPE_PROPRIETARY12,
	TEXT_LBTYPE_PROPRIETARY13,
	TEXT_LBTYPE_PROPRIETARY14,
	TEXT_LBTYPE_PROPRIETARY15,
	TEXT_LBTYPE_PROPRIETARY16,
	TEXT_NA,
	TEXT_YES,
	TEXT_NO,
	TEXT_ON,
	TEXT_OFF,
	TEXT_LB_VENDOR,
	TEXT_LB_DRIVER_NAME,
	TEXT_LB_DEFAULT_LB,
	TEXT_LB_SUPPORTED_LB,
	TEXT_LB_ALLOWS_ACT_TPG,
	TEXT_LB_ALLOWS_PATH_OV,
	TEXT_LB_SUPP_AUTO_FB,
	TEXT_LB_AUTO_FB,
	TEXT_LB_FB_POLLING_RATE,
	TEXT_LB_SUPP_AUTO_P,
	TEXT_LB_AUTO_PROB,
	TEXT_LB_PR_POLLING_RATE,
	TEXT_LB_SUPP_DEVICES,
	TEXT_LB_SUPPORTED_DEVICES,
	TEXT_LB_PRODUCT,
	TEXT_LB_REVISION,
	TEXT_LB_LOGICAL_UNIT,
	TEXT_LB_INQUIRY_NAME_TYPE,
	TEXT_NAME_TYPE_UNKNOWN,
	TEXT_NAME_TYPE_VPD83_TYPE1,
	TEXT_NAME_TYPE_VPD83_TYPE2,
	TEXT_NAME_TYPE_VPD83_TYPE3,
	TEXT_NAME_TYPE_DEVICE_SPECIFIC,
	TEXT_LB_INQUIRY_NAME,
	TEXT_LB_ASYMMETRIC,
	TEXT_LB_EXPLICIT_FAILOVER,
	TEXT_LB_CURR_LOAD_BALANCE,
	TEXT_LB_LU_GROUP_ID,
	TEXT_LB_PATH_INFO,
	TEXT_LB_INIT_PORT_NAME,
	TEXT_LB_TARGET_PORT_NAME,
	TEXT_LB_OVERRIDE_PATH,
	TEXT_LB_PATH_STATE,
	TEXT_LB_TPG_INFO,
	TEXT_LB_ACCESS_STATE,
	TEXT_LB_ID,
	TEXT_TPORT_LIST,
	TEXT_LB_NAME,
	TEXT_LB_RELATIVE_ID,
	TEXT_LB_INITATOR_PORT,
	TEXT_LB_TRANSPORT_TYPE,
	TEXT_LB_OS_DEVICE_FILE,
	TEXT_LB_PATH_COUNT,
	TEXT_LB_OP_PATH_COUNT,
	TEXT_LB_MPATH_SUPPORT,
	TEXT_PROPRIETARY,
	TEXT_LB_ENABLED,
	TEXT_LB_DISABLED,
	TEXT_UNKNOWN_OBJECT,
	TEXT_MPSTATUS_SUCCESS,
	TEXT_MPSTATUS_INV_PARAMETER,
	TEXT_MPSTATUS_UNKNOWN_FN,
	TEXT_MPSTATUS_FAILED,
	TEXT_MPSTATUS_INSUFF_MEMORY,
	TEXT_MPSTATUS_INV_OBJ_TYPE,
	TEXT_MPSTATUS_OBJ_NOT_FOUND,
	TEXT_MPSTATUS_UNSUPPORTED,
	TEXT_MPSTATUS_FN_REPLACED,
	TEXT_MPSTATUS_ACC_STATE_INVAL,
	TEXT_MPSTATUS_PATH_NONOP,
	TEXT_MPSTATUS_TRY_AGAIN,
	TEXT_MPSTATUS_NOT_PERMITTED,
	ERR_NO_MPATH_SUPPORT_LIST,
	ERR_CANT_FIND_MPATH_SUPPORT,
	ERR_CANT_FIND_MPATH_SUPPORT_WITH_NAME,
	ERR_NO_PROPERTIES,
	ERR_NO_SUPP_DEVICE_INFO,
	ERR_NO_LU_LIST,
	ERR_NO_ASSOCIATED_LU,
	ERR_LU_NOT_FOUND_WITH_MISSING_LU_STR,
	ERR_NO_LU_PATH_INFO_WITH_MISSING_LU_STR,
	ERR_NO_LU_PATH_INFO,
	ERR_NO_ASSOC_TPGS,
	ERR_NO_ASSOC_TPORTS,
	ERR_NO_INIT_PORTS,
	ERR_NO_INIT_PORT_LIST_WITH_REASON,
	ERR_INIT_PORT_NOT_FOUND_WITH_MISSING_LU_STR,
	ERR_FAILED_TO_REGISTER_PLUGIN_NAME_WITH_REASON,
	ERR_FAILED_TO_DEREGISTER_PLUGIN_NAME_WITH_REASON,
	ERR_FAILED_TO_CHANGE_OPTION_WITH_REASON,
	ERR_FAILED_TO_ENABLE_PATH_WITH_REASON,
	ERR_FAILED_TO_DISABLE_PATH_WITH_REASON,
	ERR_FAILED_TO_OVERRIDE_PATH_WITH_REASON,
	ERR_LU_NOT_ASYMMETRIC,
	ERR_NO_FAILOVER_ALLOWED,
	ERR_FAILED_TO_FAILOVER_WITH_LU_AND_REASON,
	ERR_FAILED_TO_FAILOVER_WITH_REASON,
	ERR_FAILED_TO_CANCEL_OVERRIDE_PATH_WITH_REASON,
	ERR_FAILED_TO_FIND_PATH,
	LU_NOT_FOUND,
	FAILED_TO_FIND_PATH,
	MISSING_LU_NAME,
	MISSING_INIT_PORT_NAME,
	MISSING_TARGET_PORT_NAME,
	ERR_MEMORY_ALLOCATION,
	TEXT_MORE_INFO,
	TEXT_UNABLE_TO_COMPLETE,
	ERR_FILE_DESCRIPTOR,
	ERR_DEVID,
	ERR_LU_ACCESS_STATE_UNCHANGED,
	TEXT_AUTO_FAILBACK,
	TEXT_AUTO_PROBING,
	TEXT_LOAD_BALANCE,
	TEXT_ILLEGAL_ARGUMENT,
	TEXT_MPATH_SUPPORT_NOT_FOUND,
	TEXT_PATH_STATE_OKAY,
	TEXT_PATH_STATE_PATH_ERR,
	TEXT_PATH_STATE_LU_ERR,
	TEXT_PATH_STATE_RESERVED,
	TEXT_PATH_STATE_REMOVED,
	TEXT_PATH_STATE_TRANSITIONING,
	TEXT_PATH_STATE_OPERATIONAL_CLOSED,
	TEXT_PATH_STATE_INVALID_CLOSED,
	TEXT_PATH_STATE_OFFLINE_CLOSED,
	TEXT_ACCESS_STATE_ACTIVE_OPTIMIZED,
	TEXT_ACCESS_STATE_ACTIVE_NONOPTIMIZED,
	TEXT_ACCESS_STATE_STANDBY,
	TEXT_ACCESS_STATE_UNAVAILABLE,
	TEXT_ACCESS_STATE_TRANSITIONING,
	TEXT_ACCESS_STATE_ACTIVE,
	TEXT_ANY_DEVICE,
	TEXT_TRANS_PORT_TYPE_MPNODE,
	TEXT_TRANS_PORT_TYPE_FC,
	TEXT_TRANS_PORT_TYPE_SPI,
	TEXT_TRANS_PORT_TYPE_ISCSI,
	TEXT_TRANS_PORT_TYPE_IFB
};

#ifdef	__cplusplus
}
#endif

#endif /* _MPATHADM_TEXT_H */
