/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */
/*
 * Copyright (c) 1996-1998 by Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef _MEMA_SF_PROM_H
#define	_MEMA_SF_PROM_H

#pragma ident	"%Z%%M%	%I%	%E% SMI"

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned char mema_disabled_t;

extern int prom_read_disabled_list(mema_disabled_t *, int);
extern int prom_write_disabled_list(mema_disabled_t *, int);
extern int prom_viable_disabled_list(mema_disabled_t *);

#define	PROM_MEMORY_DISABLED	0x02
#define	PROM_MEMORY_PRESENT	0x04	/* for viable check */

#ifdef __cplusplus
}
#endif

#endif /* _MEMA_SF_PROM_H */
