/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */
/*
 * Copyright (c) 1995, by Sun Microsystems, Inc.
 * All rights reserved.
 */

#pragma	ident	"%Z%%M%	%I%	%E% SMI"

#include <unistd.h>
#include <sys/fcntl.h>
#include <sys/errno.h>

#include "chkpath.h"

int
open(char *path, int flags, int mode)
{
	return (bc_open(path, flags, mode));
}
	
int
bc_open(char *path, int flags, int mode)
{
	CHKNULL(path);
	if (flags & FNDELAY) {
		flags &= ~FNDELAY;
		flags |= O_NONBLOCK;
	}
	return (open_com(path, flags, mode));
}
