/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */
/*  Copyright (c) 1988 AT&T */
/*    All Rights Reserved   */


/*
 *      Copyright (c) 1997, by Sun Microsystems, Inc.
 *      All rights reserved.
 */


#pragma ident	"%Z%%M%	%I%	%E% SMI"

#include	<sys/types.h>
#include	"curses_inc.h"

/*
 *	Add to 'win' at most n 'characters' of code starting at(cury, curx)
 */
int
waddnwstr(WINDOW *win, wchar_t *code, int n)
{
	char	*sp;

	/* translate the process code to character code */
	if ((sp = _strcode2byte(code, NULL, n)) == NULL)
		return (ERR);

	/* now call waddnstr to do the real work */
	return (waddnstr(win, sp, -1));
}
