/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */
/*
 * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
#ifndef	__MGMT_SYM_H__
#define	__MGMT_SYM_H__

#define	MMS_MGMT_ERR_OFFSET		2000
#define	MMS_MGMT_NOARG			2001
#define	MMS_MGMT_ERR_EXEC_SSI		2002
#define	MMS_MGMT_ERR_ACSLS_COMM		2003
#define	MMS_MGMT_ERR_ACSLS_RSP		2004
#define	MMS_MGMT_ERR_ACSLS_PARSE	2005
#define	MMS_MGMT_ERR_REQUIRED		2006
#define	MMS_MGMT_NO_MMHOST		2007
#define	MMS_MGMT_CARTRIDGE_INUSE	2008
#define	MMS_MGMT_DBDUMP_MISSING		2009
#define	MMS_MGMT_RSP_UNKNOWN		2010
#define	MMS_MGMT_RSP_CANCELLED		2011
#define	MMS_MGMT_REQ_NOT_ACCEPTED	2012
#define	MMS_MGMT_ERR_GROUP		2013
#define	MMS_MGMT_ERR_USER		2014
#define	MMS_MGMT_ERR_SVRONLY		2015
#define	MMS_MGMT_ERR_CART_NOT_UNIQUE	2016
#define	MMS_MGMT_ERR_PARTITION_NOT_UNIQUE 2017
#define	MMS_MGMT_VOL_NOT_INIT		2018
#define	MMS_MGMT_NO_USABLE_VOL		2019
#define	MMS_MGMT_ACSLS_NOT_FOUND	2020
#define	MMS_MGMT_MMS_NOT_INIT		2021
#define	MMS_MGMT_REMOTE_NOT_SUPP	2022
#define	MMS_MGMT_PASSWORD_REQUIRED	2023
#define	MMS_MGMT_VOL_NOT_MOUNTED	2024
#define	MMS_MGMT_NOT_AUTHORIZED		2025
#define	MMS_MGMT_PASSWD_MISMATCH	2026
#define	MMS_MGMT_GETPASS_FAILED		2027
#define	MMS_MGMT_PASSTOOSHORT		2028
#define	MMS_MGMT_MMP_PARSE_ERR		2029
#define	MMS_MGMT_APP_VOLS_EXIST		2030
#define	MMS_MGMT_NOT_DBFILE		2031
#define	MMS_MGMT_DB_USER_NOTFOUND	2032
#define	MMS_MGMT_INVALID_PATH		2033
#define	MMS_MGMT_INV_HOSTPATH		2034
#define	MMS_MGMT_LIB_EXISTS		2035
#define	MMS_MGMT_LIB_NOT_EXIST		2036
#define	MMS_MGMT_NO_HWTYPE		2037
#define	MMS_MGMT_NO_VOLTYPE		2038
#define	MMS_MGMT_DFLTPATH_ERR		2039
#define	MMS_MGMT_DG_NOT_EXIST		2040
#define	MMS_MGMT_CG_NOT_EXIST		2041
#define	MMS_MGMT_SHOW_CT_ERR		2042
#define	MMS_MGMT_CT_NOT_EXIST		2043
#define	MMS_MGMT_SN_ERR			2044
#define	MMS_MGMT_REQ_ARG		2045
#define	MMS_MGMT_CREATE_PART_ERR	2046
#define	MMS_MGMT_CREATE_CART_ERR	2047
#define	MMS_MGMT_INVALID_READONLY	2048

#define	MMS_MGMT_LAST_ERR_CODE		2200	/* Must be last */

#endif	/* __MGMT_SYM_H__ */
